/*-------------------------------------------------------------------------
   Register Declarations for the Intel 8052 Processor

   Written By -  Bela Torok / bela.torok@kssg.ch (July 2000)
   		 Krzysztof Mazur <krzysiek@podlesie.net> (August 2006)

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

   In other words, you are welcome to use, share and improve this program.
   You are forbidden to forbid anyone else to use, share and improve
   what you give them.   Help stamp out software-hoarding!
-------------------------------------------------------------------------*/

#ifndef REG8052_H
#define REG8052_H

#include <asm/8051.h>     /* load difinitions for the 8051 core */

#ifdef REG8051_H
#undef REG8051_H
#endif

/* define 8052 specific registers only */

/* T2CON */
DEFINE_SFR(T2CON, 0xC8)

/* RCAP2 L & H */
DEFINE_SFR(RCAP2L, 0xCA)
DEFINE_SFR(RCAP2H, 0xCB)
DEFINE_SFR(TL2, 0xCC)
DEFINE_SFR(TH2, 0xCD)

/*  IE   */
DEFINE_SBIT(ET2, 0xAD)		/* Enable timer2 interrupt */

/* T2CON bits */
DEFINE_SBIT(T2CON_0, 0xC8)
DEFINE_SBIT(T2CON_1, 0xC9)
DEFINE_SBIT(T2CON_2, 0xCA)
DEFINE_SBIT(T2CON_3, 0xCB)
DEFINE_SBIT(T2CON_4, 0xCC)
DEFINE_SBIT(T2CON_5, 0xCD)
DEFINE_SBIT(T2CON_6, 0xCE)
DEFINE_SBIT(T2CON_7, 0xCF)

DEFINE_SBIT(CP_RL2, 0xC8)
DEFINE_SBIT(C_T2, 0xC9)
DEFINE_SBIT(TR2, 0xCA)
DEFINE_SBIT(EXEN2, 0xCB)
DEFINE_SBIT(TCLK, 0xCC)
DEFINE_SBIT(RCLK, 0xCD)
DEFINE_SBIT(EXF2, 0xCE)
DEFINE_SBIT(TF2, 0xCF)

/* AT89S251 */

DEFINE_SFR(WMCON, 0x96)

#define WDTEN		0x01
#define	WDTRST		0x02

#define WRTINH		0x01
#define RDY		0x02
#define DPS		0x04
#define EEMEN		0x08
#define EEMWE		0x10
#define EELD		0x20

#ifdef CONFIG_AT89S8253
DEFINE_SFR(CLKREG, 0x8F)

#define CLKREG_X2	1
#endif

#ifdef BRG

DEFINE_SFR(BRL, 0x9A)
DEFINE_SFR(BDRCON, 0x9B)

#define BDRCON_SRC	0x01
#define BDRCON_SPD	0x02
#define BDRCON_RBCK	0x04
#define BDRCON_TBCK	0x08
#define BDRCON_BRR	0x10

#endif

#endif
